#!/usr/bin/env python3

import re
from collections import OrderedDict

def edit(text):
    if type(text) != str:
        raise TypeError('"text" argument must be str, not {0}'.format(type(text)))
    
    text = re.sub('"|\'|\"|\(|\)|\[|\]|,|;|:|\*', '', text)
    return text

def tokenize(text,
             wordize = True,
             gramize = True,
             lowerize = True):
    if type(text) != str:
        raise TypeError('"text" argument must be str, not {0}'.format(type(text)))
    if type(wordize) != bool:
        raise TypeError('"wordize" argument must be bool, not {0}.'.format(type(wordize)))
    if type(gramize) != bool:
        raise TypeError('"gramize" argument must be bool, not {0}.'.format(type(gramize)))
    if type(lowerize) != bool:
        raise TypeError('"lowerize" argument must be bool, not {0}.'.format(type(lowerize)))
    
    tokens = []
    upr = '\. |\.\.\. |! |\? |; |: |!\? |!!! | |, | "|" |\n'
    clist = ['.', ',', '?', '!', ';' ':', '-', '*']
    
    if wordize == True:
        if gramize == True:
            cents = re.split('\. |\.\.\. |! |\? |; |: |!\? |!!! |\n', text)
            for cent in cents:
                box = re.split(' |, | "|" ', cent)
                box = [re.sub('\.|"|\'|\?|\*|:|;', '', token) for token in box]
                for i in range(len(box)):
                    try: box.remove('')
                    except ValueError: break
                for i in range(len(box)):
                    try: box.remove('-')
                    except ValueError: break
                if lowerize == True: box = [token.lower() for token in box]
                else: pass
                box = tuple(box)
                tokens.append(box)
                del box
            del cents
        else:
            box = re.split(upr, text)
            box = [re.sub('\.|"|\'|\?|\*|:|;', '', token) for token in box]
            for i in range(len(box)):
                try: box.remove('')
                except ValueError: break
            for i in range(len(box)):
                try: box.remove('-')
                except ValueError: break
            if lowerize == True: tokens = [token.lower() for token in box]
            else: tokens = box
            del box
            
    else:
        if gramize == True:
            tkns = re.split(upr, text)
            box = []
            for token in tkns:
                slot1 = []
                token = list(token)
                for char in token:
                    if char in clist: pass
                    else: slot1.append(char)
                slot1 = tuple(slot1)
                box.append(slot1)
                del slot1
            tokens = box
            del box
            del tkns
        else:
            tkns = re.split(upr, text)
            for token in tkns:
                token = list(token)
                for char in token:
                    if char in clist: pass
                    else: tokens.append(char)
            del tkns
    
    try:
        if type(tokens[0]) == tuple:
            for limit in tokens:
                if len(limit) == 0:
                    tokens.remove(limit)
    except IndexError:
        pass
    
    del upr
    return tokens